//-----------------------------------------------------------------------------
// Copyright  2007 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/angif
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This library is "patent free" in that it contains no code to implement
// the LZW compression, which is covered by patent number 4,558,302 owned
// by Unisys.  Image data generated by this library is not compressed.
//
// GIF is a service mark, property of CompuServe, Inc.
//
// The GIF standard is obsolete and is being deprecated in favor of the
// PNG (Portable Network Graphics) standard.
//-----------------------------------------------------------------------------
#ifndef __ANGIF_LIB_H__
#define __ANGIF_LIB_H__

#include "libh_common.h"

#include <errno.h>
#include <limits.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <libh/angif.h>

//-----------------------------------------------------------------------------
// ANGIF_DEFAULT_GAMMA is the default gamma correction value:
// decimal: 2.44265300408029158662180646555128760155639611184597015380859375
// hexadecimal: 0x9.c546d4400107f57p-2
// ANGIF_COLOR_MODULUS is used for hashing the color table lookups.
//-----------------------------------------------------------------------------
#define ANGIF_DEFAULT_GAMMA		2.44265300408029158662180646555128760155639611184597015380859375
#define ANGIF_COLOR_MODULUS		1999
#define ANGIF_MINIMUM_BUFFER_SIZE	256
#define ANGIF_INITAL_BUFFER_SIZE	256

#endif /* __ANGIF_LIB_H__ */
