//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/arith
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include <stdlib.h>
#include <stdio.h>

#include <libh/arith.h>

//-----------------------------------------------------------------------------
// proram	gcd
//
// purpose	Determine the greatest common denominator by Euclid's algorithm
//		for type unsigned long long and output the GCD.
//
// syntax	gcd  number1  number2
//-----------------------------------------------------------------------------
int
main (
    int		argc
    ,
    char * *	argv
    ,
    char * *	envp
    )
{
    //-- Make sure we have arguments.
    if ( argc <= 2 ) {
	fprintf( stderr, "syntax:  testgcd  number1  number2\n" );
	return 1;
    }

    //-- Print result from function.
#if HAVE_C99
    printf( "%20llu\n", gcd_ull( strtoull( argv[1], NULL, 0 ), strtoull( argv[2], NULL, 0 ) ) );
#else
    printf( "%10lu\n", gcd_ul( strtoul( argv[1], NULL, 0 ), strtoul( argv[2], NULL, 0 ) ) );
#endif

    return 0;
}
