__PREFIX_BEGIN__
//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/arith
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// file		arith.h
//
// purpose	Define resources used by and with the arith library.
//-----------------------------------------------------------------------------
#ifndef __ARITH_H__
#define __ARITH_H__

__PREFIX_END__

__CONFIG_BEGIN__
//-----------------------------------------------------------------------------
// configuration
//-----------------------------------------------------------------------------
// Define various gamma values.
//-----------------------------------------------------------------------------
#define PIX_GAMMA_PC		2.2
#define PIX_GAMMA_MAC		1.8
#define PIX_GAMMA_LCD		2.5
#define PIX_GAMMA_GRAY192	2.4094208396532090048

__CONFIG_END__

__DEFINE_BEGIN__
#ifndef	LIBH_LONG_DOUBLE_MATH

#define LIBH_LONG_DOUBLE_MATH	1

#ifdef __NO_LONG_DOUBLE_MATH

#define acoshl(x)	((long double)acosh((double)(x)))
#define acosl(x)	((long double)acos((double)(x)))
#define asinhl(x)	((long double)asinh((double)(x)))
#define asinl(x)	((long double)asin((double)(x)))
#define atanhl(x)	((long double)atanh((double)(x)))
#define atanl(x)	((long double)atan((double)(x)))

#define coshl(x)	((long double)cosh((double)(x)))
#define cosl(x)		((long double)cos((double)(x)))

#define expl(x)		((long double)exp((double)(x)))

#define frexpl(x,e)	((long double)(frexp(((double)(x)),(e))))

#define logl(x)		((long double)log((double)(x)))
#define log10l(x)	((long double)log10((double)(x)))

#define powl(x,y)	((long double)pow(((double)(x)),((double)(y)))

#define sinhl(x)	((long double)sinh((double)(x)))
#define sinl(x)		((long double)sin((double)(x)))
#define sqrtl(x)	((long double)sqrt((double)(x)))

#define tanhl(x)	((long double)tanh((double)(x)))
#define tanl(x)		((long double)tan((double)(x)))

#define libh_powl	pow

#else

#define libh_powl	powl

#endif

#endif

__DEFINE_END__

__SUFFIX_BEGIN__
#endif /* __ARITH_H__ */
__SUFFIX_END__
