//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/arith
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	gcd
//
// purpose	Determine the greatest common denominator by Euclid's algorithm
//		for any integer type.
//
// arguments	1 (integer) 1st number
//		2 (integer) 2nd number
//
// returns	(integer) greatest common denominator
//-----------------------------------------------------------------------------
#define gcd(a,b) ({								\
	__typeof__((a)) libh__a = (a);						\
	__typeof__((b)) libh__b = (b);						\
	if ( libh__a < libh__b ) {						\
		__typeof__((a)) libh__c = libh__a;				\
		libh__a = libh__b;						\
		libh__b = libh__c;						\
	}									\
	while ( libh__b ) {							\
		__typeof__((a)) libh__c = libh__a % libh__b;			\
		libh__a = libh__b;						\
		libh__b = libh__c;						\
	}									\
	libh__a;								\
})

__FMACRO_END__
