//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/arith
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	ipow
//
// purpose	Raise a number to an integer power and return the result.
//
// arguments	1 (number) number to raise
//		2 (int) power to raise
//
// returns	(number) power result
//-----------------------------------------------------------------------------
#define ipow(n,p) ({								\
	__typeof__(n)	libh__n;						\
	__typeof__(n)	libh__a;						\
	int		libh__p;						\
	int		libh__m;						\
	libh__n = (n);								\
	libh__p = (p);								\
	libh__a = ( __typeof__(n) ) 1;						\
	libh__m = 1;								\
	while ( libh__m <= libh__p ) {						\
		if ( libh__m & libh__p ) libh__a *= libh__n;			\
		libh__n *= libh__n;						\
		libh__m += libh__m;						\
	}									\
	libh__a;								\
})

__FMACRO_END__
