//-----------------------------------------------------------------------------
// Copyright  2006 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/arith
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	pix_rgb10_ftoi
//
// purpose	Convert three floating point (double) pixel intensity values
//		in the range 0.0 .. 1.0 to a single gamma corrected color code
//		(int) value with the low order 30 bits representing the color
//		code in triple 10-bit format.
//
// arguments	1 (double) gamma correction factor to use
//		2 (double) pixel intensity for 1st color (usually red)
//		3 (double) pixel intensity for 2nd color (usually green)
//		4 (double) pixel intensity for 3rd color (usually blue)
//
// returns	(int) gamma corrected R10,G10,B10 color code
//-----------------------------------------------------------------------------
#define pix_rgb10_ftoi(m,r,g,b) ({						\
	double libh__m;								\
	libh__m = (m);								\
	if ( libh__m <= 0.0 ) libh__m = PIX_DEFAULT_GAMMA;			\
	( ( pix_ftoi_base( libh__m, (r), 1024 ) << 20 ) & 0x3ff00000 ) +	\
	( ( pix_ftoi_base( libh__m, (g), 1024 ) << 10 ) & 0x000ffc00 ) +	\
	( ( pix_ftoi_base( libh__m, (b), 1024 )       ) & 0x000003ff );		\
})

__FMACRO_END__
