//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/arith
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "arith_lib.h"

__PROTO_BEGIN__
//-----------------------------------------------------------------------------
// function	rescale_d
//
// purpose	Given a new linear number range and an old linear number range,
//		rescale a number from the old range to the new range and return
//		the result.
//
// arguments	1 (double) 1st value of new number range
//		2 (double) 2nd value of new number range
//		3 (double) 1st value of old number range
//		4 (double) 2nd value of old number range
//		5 (double) number in old range to rescale to new range
//
// returns	(double) number rescaled to new range
//-----------------------------------------------------------------------------
double
rescale_d (
    double		arg_new_a
    ,
    double		arg_new_z
    ,
    double		arg_old_a
    ,
    double		arg_old_z
    ,
    double		arg_num
    )
__PROTO_END__
{
    return rescale( arg_new_a, arg_new_z, arg_old_a, arg_old_z, arg_num );
}
