//-----------------------------------------------------------------------------
// program	invert_2x2
//
// purpose	Test the mat_inv_2x2() macro.
//
// usage	Shell command
//
// syntax	invert_2x2  a b c d
//
// action	Inverts matrix  ( a b )
//				( c d )
//-----------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>

#include <libh/arith.h>

int
main (
    int		argc
    ,
    char * *	argv
    )
{
    double	m[2][2];
    double	i[2][2];
    double	j[2][2];
    double	d;

    if ( argc != 5 ) {
	fputs( "syntax: invert_2x2 a b c d\n"
	       "        the arguments are a row order 2x2 matrix\n",
	       stderr );
	return 1;
    }

    i[0][0] = 0.0;
    i[0][1] = 0.0;
    i[1][0] = 0.0;
    i[1][1] = 0.0;

    j[0][0] = 0.0;
    j[0][1] = 0.0;
    j[1][0] = 0.0;
    j[1][1] = 0.0;

    m[0][0] = strtod( argv[1], NULL );
    m[0][1] = strtod( argv[2], NULL );
    m[1][0] = strtod( argv[3], NULL );
    m[1][1] = strtod( argv[4], NULL );

    printf( "\n" );

    printf( "matrix is  ( %13.6f  %13.6f )\n", m[0][0], m[0][1] );
    printf( "           ( %13.6f  %13.6f )\n", m[1][0], m[1][1] );
    printf( "\n" );

    d = mat_inv_2x2( i, m );
    printf( "determinate  %13.6f\n", d );
    printf( "\n" );

    if ( d == 0.0 ) {
	printf( "matrix is singular so inverse does not exist\n" );
	printf( "\n" );
	return 0;
    }

    printf( "inverse is ( %13.6f  %13.6f )\n", i[0][0], i[0][1] );
    printf( "           ( %13.6f  %13.6f )\n", i[1][0], i[1][1] );
    printf( "\n" );

    d = mat_inv_2x2( j, i );
    printf( "determinate  %13.6f\n", d );
    printf( "\n" );

    if ( d == 0.0 ) {
	printf( "inverse matrix is singular so something is wrong\n" );
	printf( "\n" );
	return 0;
    }

    printf( "inv/inv is ( %13.6f  %13.6f )\n", j[0][0], j[0][1] );
    printf( "           ( %13.6f  %13.6f )\n", j[1][0], j[1][1] );
    printf( "\n" );

    return 0;
}

