//-----------------------------------------------------------------------------
// program	invert_3x3
//
// purpose	Test the mat_inv_3x3() macro.
//
// usage	Shell command
//
// syntax	invert_3x3  a b c d e f g h i
//
// action	Inverts matrix  ( a b c )
//				( d e f )
//				( g h i )
//-----------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>

#include <libh/arith.h>

int
main (
    int		argc
    ,
    char * *	argv
    )
{
    double	m[3][3];
    double	i[3][3];
    double	j[3][3];
    double	d;

    if ( argc != 10 ) {
	fputs( "syntax: invert_3x3 a b c d e f g h i\n"
	       "        the arguments are a row order 3x3 matrix\n",
	       stderr );
	return 1;
    }

    i[0][0] = 0.0;
    i[0][1] = 0.0;
    i[0][2] = 0.0;
    i[1][0] = 0.0;
    i[1][1] = 0.0;
    i[1][2] = 0.0;
    i[2][0] = 0.0;
    i[2][1] = 0.0;
    i[2][2] = 0.0;

    j[0][0] = 0.0;
    j[0][1] = 0.0;
    j[0][2] = 0.0;
    j[1][0] = 0.0;
    j[1][1] = 0.0;
    j[1][2] = 0.0;
    j[2][0] = 0.0;
    j[2][1] = 0.0;
    j[2][2] = 0.0;

    m[0][0] = strtod( argv[1], NULL );
    m[0][1] = strtod( argv[2], NULL );
    m[0][2] = strtod( argv[3], NULL );
    m[1][0] = strtod( argv[4], NULL );
    m[1][1] = strtod( argv[5], NULL );
    m[1][2] = strtod( argv[6], NULL );
    m[2][0] = strtod( argv[7], NULL );
    m[2][1] = strtod( argv[8], NULL );
    m[2][2] = strtod( argv[9], NULL );

    printf( "\n" );

    printf( "matrix is  ( %13.6f  %13.6f  %13.6f )\n", m[0][0], m[0][1], m[0][2] );
    printf( "           ( %13.6f  %13.6f  %13.6f )\n", m[1][0], m[1][1], m[1][2] );
    printf( "           ( %13.6f  %13.6f  %13.6f )\n", m[2][0], m[2][1], m[2][2] );
    printf( "\n" );

    d = mat_inv_3x3( i, m );
    printf( "determinate  %13.6f\n", d );
    printf( "\n" );

    if ( d == 0.0 ) {
	printf( "matrix is singular so inverse does not exist\n" );
	printf( "\n" );
	return 0;
    }

    printf( "inverse is ( %13.6f  %13.6f  %13.6f )\n", i[0][0], i[0][1], i[0][2] );
    printf( "           ( %13.6f  %13.6f  %13.6f )\n", i[1][0], i[1][1], i[1][2] );
    printf( "           ( %13.6f  %13.6f  %13.6f )\n", i[2][0], i[2][1], i[2][2] );
    printf( "\n" );

    d = mat_inv_3x3( j, i );
    printf( "determinate  %13.6f\n", d );
    printf( "\n" );

    if ( d == 0.0 ) {
	printf( "inverse matrix is singular so something is wrong\n" );
	printf( "\n" );
	return 0;
    }

    printf( "inv/inv is ( %13.6f  %13.6f  %13.6f )\n", j[0][0], j[0][1], j[0][2] );
    printf( "           ( %13.6f  %13.6f  %13.6f )\n", j[1][0], j[1][1], j[1][2] );
    printf( "           ( %13.6f  %13.6f  %13.6f )\n", j[2][0], j[2][1], j[2][2] );
    printf( "\n" );

    return 0;
}

