//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/bit
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "bit_lib.h"

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	bit_count_16
//
// purpose	Count the number of bits that are on in a 16 bit integer.
//
// arguments	(uint16_t) unsigned integer with bits to count
//
// returns	(int) <  0 : error
//		(int) >= 0 : number of bits that are on
//-----------------------------------------------------------------------------
#define bit_count_16_mask_1	UINT16_C( 0x5555 )
#define bit_count_16_mask_2	UINT16_C( 0x3333 )
#define bit_count_16_mask_3	UINT16_C( 0x0707 )
#define bit_count_16_mask_4	( (int) 0x000f )
#define bit_count_16( b ) ({							\
	uint16_t d = ( b );							\
	d = ( d >>  1 & bit_count_16_mask_1 ) + ( d & bit_count_16_mask_1 );	\
	d = ( d >>  2 & bit_count_16_mask_2 ) + ( d & bit_count_16_mask_2 );	\
	d = ( d >>  4 & bit_count_16_mask_3 ) + ( d & bit_count_16_mask_3 );	\
	( (int) ( d >> 8 ) & bit_count_16_mask_4 ) + ( (int) d & bit_count_16_mask_4 ); })

__FMACRO_END__
