//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/bit
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "bit_lib.h"

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	bit_count_ull
//
// purpose	Count the number of bits that are set to 1 in an unsigned
//		long long
//
// arguments	(unsigned long long) unsigned integer with bits to count
//
// returns	(int) <  0 : error
//		(int) >= 0 : number of bits set to 1
//-----------------------------------------------------------------------------
#ifdef ULONGLONG_MAX
#if ULONGLONG_MAX > 18446744073709551615U
#define bit_count_ull(b) bit_count_128((b))
#else
#define bit_count_ull(b) bit_count_64((b))
#endif
#else
#define bit_count_ull(b) (0)
#endif

__FMACRO_END__
