//-----------------------------------------------------------------------------
// Copyright  2006 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/bit
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "bit_lib.h"

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	low_bits_on_u32
//
// purpose	Yield a constant expression that can be evaluated at compile
//		time to the uint32_t value with the specified number of bits
//		being 1, when the given value is a constant.
//
// arguments	1 (int) number of bits to be on
//
// yields	(uint32_t) value with specified number of bits on
//-----------------------------------------------------------------------------
#define low_bits_on_u32(n) ( (uint32_t) (					\
	(n) <= UINT32_C(0)							\
	? UINT32_C(0)								\
	: ( ( UINT32_C(1) << (n) ) | ( ( UINT32_C(1) << (n) ) - UINT32_C(1) ) )	\
) )

__FMACRO_END__
