//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/byte
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "byte_lib.h"

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	int_to_bytes_be
//
// purpose	Store a given integer value into a specified number of bytes
//		in big endian order.
//
// arguments	1 (integer) value to store
//		2 (int) number of bytes to store into
//		3 (unsigned char *) pointer to bytes to store into
//
// yields	(void)
//-----------------------------------------------------------------------------
#define int_to_bytes_be(i,n,p) ({						\
	__type_of__((i)) libh__i;						\
	unsigned char *libh__p;							\
	unsigned char *libh__q;							\
	libh__i = (i);								\
	libh__p = (p);								\
	libh__q = libh__p + (n);						\
	while ( libh__q > libh__p ) {						\
		* -- libh__q = libh__i & 0x00ff;				\
		libh__i >>= 8;							\
	}									\
})

__FMACRO_END__
