//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/byte
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "byte_lib.h"

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	uint_to_2_bytes_le
//
// purpose	Store a given integer value into 2 bytes in little endian order.
//
// arguments	1 (integer) value to store
//		2 (unsigned char *) pointer to bytes to store into
//
// yields	(void)
//-----------------------------------------------------------------------------
#define uint_to_2_bytes_le(n,p) ({						\
	uint16_t libh__n;							\
	unsigned char *libh__p;							\
	libh__n = (n);								\
	libh__p = (p);								\
	* libh__p ++ = libh__n & 0x00ff;					\
	libh__n >>= 8;								\
	* libh__p = libh__n & 0x00ff;						\
})

__FMACRO_END__
