//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/ctools
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// file		callcountry.c
//
// program	callcountry
//
// purpose	Convert a radio call sign into the name of the country the
//		call sign is from.
//
// usage	Shell command
//
// syntax	callcountry  [ call sign ... ]
//-----------------------------------------------------------------------------
#include <stdio.h>
#include <libh/callsign.h>

int
main (
    int		argc
    ,
    char * *	argv
)
{
    const char *	country_code	;
    const char *	country_name	;

    while ( -- argc && * ++ argv ) {
	country_code = callsign_to_country_code( * argv );
	if ( ! country_code ) {
	    printf( "%-12s ** invalid call sign\n", * argv );
	    continue;
	}
	if ( * country_code == '-' ) {
	    printf( "%-12s -- reserved or unassigned to a country\n", * argv );
	    continue;
	}
	country_name = country_to_name_short( country_code );
	if ( ! country_name ) {
	    printf( "%-12s ?? unknown country name for code \"%s\"\n", * argv, country_code );
	    continue;
	}
	printf( "%-12s %s %s\n", * argv, country_code, country_name );
    }
    return 0;
}
