//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/callsign
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	callsign_to_country_name_short
//
// purpose	Given a radio callsign, return the country short name for
//		the country the callsign is in the range for.
//
// argument	1 (const char *) callsign string
//
// returns	(const char *) NULL : ambiguous (e.g. a callsign like "a")
//		(const char *) short name of country for this callsign range
//
// note		Do not modify the returned string.
//-----------------------------------------------------------------------------
#define callsign_to_country_name_short(c) ({					\
	const struct country_call * __country_p;				\
	__country_p = country_by_call((c));					\
	__country_p ? country_to_name_short( __country_p->code ) : NULL;	\
})

__FMACRO_END__
