//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/callsign
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	country_to_name_sorting
//
// purpose	Given a country code (or a special code for international
//		administrative units), return a pointer to the sorting name
//		of that country (or international administrative unit).
//
// argument	1 (const char *) country code string
//
// returns	(const char *) NULL : unknown code
//		(const char *) country sorting name string
//
// note		Do not modify the returned string.
//-----------------------------------------------------------------------------
#define country_to_name_sorting(c) ({						\
	struct country_name * __country_entry_p;				\
	__country_entry_p = country_to_name_entry( ( c ) );			\
	( __country_entry_p ) ? __country_entry_p->name_sorting : NULL;		\
})

__FMACRO_END__
