//-----------------------------------------------------------------------------
// Copyright  2010 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/ctools
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	char_code_5
//
// purpose	Convert 5 characters to an integer code value.
//
// arguments	1 (unsigned char) 1st character, highest order
//		2 (unsigned char) 2nd character
//		3 (unsigned char) 3rd character
//		4 (unsigned char) 4th character
//		5 (unsigned char) 5th character, lowest order
//
// yields	(uint64_t) result code
//-----------------------------------------------------------------------------
#define char_code_5(a,b,c,d,e) (((uint64_t)(a)<<32&0xff00000000ULL)+	\
				((uint64_t)(b)<<24&0xff000000ULL)+	\
				((uint64_t)(c)<<16&0xff0000ULL)+	\
				((uint64_t)(d)<<8&0xff00ULL)+		\
				((uint64_t)(e)&0xffULL))

__FMACRO_END__
