//-----------------------------------------------------------------------------
// Copyright  2006 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/ctools
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "ctools_lib.h"

#include <stdarg.h>
#include <stdlib.h>

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	env_d
//
// purpose	Select the first defined environment variable from a given list
//		and convert it to type double, or use the default if not found.
//
// arguments	1 (double) default value
//		2..N (const char *) list of variable names, ending in NULL
//
// returns	(double) the converted or default value.
//-----------------------------------------------------------------------------
#define env_d(d,n...) ({							\
	const char * libh__str;							\
	libh__str = ( env_str( n , ( (const char*) (NULL) ) ) );		\
	( libh__str && * libh__str )						\
		? strtod( libh__str, NULL )					\
		: ( d );							\
})

__FMACRO_END__
