//-----------------------------------------------------------------------------
// Copyright  2010 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/ctools
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	for_each_str
//
// purpose	Iterate a loop for each of the given strings.
//
// arguments	1 (name) iterator variable to be defined
//		2..N (const char *) strings to be iterated over
//
// yields	A for loop construct to be followed by code body
//
// example	for_each_of ( p, "foo", "bar" ) puts( p );
//-----------------------------------------------------------------------------
#define for_each_str(v,s...) for(const char*v,**libh__for_each_str_p=({static const char*libh__for_each_str_pp[]={s,(NULL)};libh__for_each_str_pp;});(v=*libh__for_each_str_p);++libh__for_each_str_p)

__FMACRO_END__
