//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/ctools
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	limit_low
//
// purpose	Limit the given value to a specified range.  If the value is
//		lower than the low limit, return the low limit itself.
//		Otherwise return the actual value.
//
// arguments	1 (scalar) value to be limited
//		2 (scalar) low limit
//
// returns	(scalar) the limited value
//-----------------------------------------------------------------------------
#define limit_low(v,l) ({							\
	__typeof__( ( v ) ) __v;						\
	__typeof__( ( l ) ) __l;						\
	__v = ( v );								\
	__l = ( l );								\
	__v < __l ? __l : __v; })

__FMACRO_END__
