//-----------------------------------------------------------------------------
// Copyright  2012 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/ctools
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	lteqgt
//
// purpose	Yield one of 3 values based on 1st value being less than,
//		equal, or greater than, 2nd value.
//
// arguments	1 (number) value 1 to compare
//		2 (number) value 2 to compare
//		3 (number) value to yield for less than
//		4 (number) value to yield for equal
//		5 (number) value to yield for greater than
//
// usage	As replacement for if statements.
//-----------------------------------------------------------------------------
#define lteqgt(a,b,l,e,g) ((a)<(b)?(l):(a)>(b)?(g):(e))

//-----------------------------------------------------------------------------
// macro	lteqgtz
//
// purpose	Yield one of 3 values based on a value being less than,
//		equal, or greater than, zero.
//
// arguments	1 (number) value to compare to zero
//		2 (number) value to yield for less than
//		3 (number) value to yield for equal
//		4 (number) value to yield for greater than
//
// usage	As replacement for if statements.
//-----------------------------------------------------------------------------
#define lteqgtz(a,l,e,g) ((a)<0?(l):(a)>0?(g):(e))

__FMACRO_END__
