//-----------------------------------------------------------------------------
// Copyright  2010 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/ctools
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	one_of_string_nocase
//
// purpose	Determine if the given string is equal to one of a list,
//		while ignoring alphabetic case.
//
// arguments	1 (const char *) string to be compared to the others
//		2..N (const char *) strings the first is compared with
//
// yields	true (1) if the first string is equal to one of the others
//		false (0) otherwise
//
// example	if (one_of_string(s,"one","two","three","four")) puts("yes")
//		else puts("no");
//-----------------------------------------------------------------------------
#define one_of_string_nocase(s,x...) ({						\
	const char * const * ___p___;						\
	const char * ___s___;							\
	static const char * const ___x___[] = { x, (NULL) };			\
	___s___ = (s);								\
	for ( ___p___ = ___x___; * ___p___; ++ ___p___ ) {			\
		if ( strcasecmp( * ___p___, ___s___ ) == 0 ) break;		\
	}									\
	* ___p___ ? 1 : 0;							\
})

__FMACRO_END__
