//-----------------------------------------------------------------------------
// Copyright  2006 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/ctools
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	libh_swap
//
// purpose	Swap the values of two variables or structs of like type.
//		Both must be given as lvalues the & operator can be used on.
//
// arguments	1 (lvalue variable)
//		2 (lvalue variable)
//
// returns	(void)
//
// note		This is not optimized for large structs.
//-----------------------------------------------------------------------------
#define libh_swap(a,b) (void)({							\
	__typeof__(a) *libh__a;							\
	__typeof__(b) *libh__b;							\
	__typeof__(a) libh__t;							\
	(void) ( libh__a == libh__b );						\
	libh__a=&(a);								\
	libh__b=&(b);								\
	libh__t=*libh__a;							\
	*libh__a=*libh__b;							\
	*libh__b=libh__t;							\
})

#ifndef LIBH_NO_swap
//-----------------------------------------------------------------------------
// macro	swap
//
// purpose	Swap the values of two variables or structs of like type.
//		Both must be given as lvalues the & operator can be used on.
//
// arguments	1 (lvalue variable)
//		2 (lvalue variable)
//
// returns	(void)
//
// note		This is not optimized for large structs.
//-----------------------------------------------------------------------------
#define swap(a,b) (void)({							\
	__typeof__(a) *libh__a;							\
	__typeof__(b) *libh__b;							\
	__typeof__(a) libh__t;							\
	(void) ( libh__a == libh__b );						\
	libh__a=&(a);								\
	libh__b=&(b);								\
	libh__t=*libh__a;							\
	*libh__a=*libh__b;							\
	*libh__b=libh__t;							\
})
#endif

__FMACRO_END__
