//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/divd
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include <stdlib.h>
#include <stdio.h>

#include <libh/div.h>

int
main (
    int		argc
    ,
    char * *	argv
    )
{
    int		first		;
    int		last		;
    int		divisor		;
    int		step		;
    int		dividend	;

    if ( argc <= 3 ) {
	fprintf( stderr, "divdtest: divisor first last [step]\n" );
	return 1;
    }

    divisor	= strtol( argv[1], NULL, 0 );
    first	= strtol( argv[2], NULL, 0 );
    last	= strtol( argv[3], NULL, 0 );

    if ( argc > 4 ) {
	step	= strtol( argv[4], NULL, 0 );
    } else {
	step = 1;
	if ( first > last ) step = -1;
    }

    dividend = first;
    while ( ( first > last ) ? ( dividend > last ) : ( dividend < last ) ) {
	printf( "TTZ: %3d / %2d = %2d + rem( %2d )"
		"                "
		"TTNI: %3d / %2d = %2d + mod( %2d )"
		"\n",
		dividend,
		divisor,
		dividend / divisor,
		dividend % divisor,
		dividend,
		divisor,
		quo_ni( dividend, divisor ),
		mod_ni( dividend, divisor ) );
	dividend += step;
    }
    return 0;
}
