//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/div
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	divq
//
// purpose	Calculate the quotient and remainder (e.g. x/y and x%y) at the
//		same time via the div() standard function, but instead of
//		returning a div_t structure, return the quotient and store the
//		remainder in the location specified in the 3rd argument.
//
// arguments	1 (int) divident
//		2 (int) divisor
//		3 (integer *) where to store remainder
//
// returns	(int) quotient
//-----------------------------------------------------------------------------
#define divq(x,y,r) ({								\
	div_t libh__dt;								\
	__typeof__( (r) ) libh__r;						\
	libh__dt = div( (x), (y) );						\
	libh__r = (r);								\
	if ( libh__r ) * libh__r = libh__dt.rem;				\
	libh__dt.quot;								\
})

__FMACRO_END__
