//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/div
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	lldivqr
//
// purpose	Calculate the quotient and remainder (e.g. x/y and x%y) at the
//		same time via the lldiv() standard function, but instead of
//		returning a lldiv_t structure, store the quotient in the location
//		specified in the 3rd argument and store the remainder in the
//		location specified in the 4th argument.
//
// arguments	1 (long long) divident
//		2 (long long) divisor
//		3 (integer *) where to store quotient
//		4 (integer *) where to store remainder
//
// returns	(int) 0
//-----------------------------------------------------------------------------
#define lldivqr(x,y,q,r) ({							\
	lldiv_t libh__dt;							\
	__typeof__( (q) ) libh__q;						\
	__typeof__( (r) ) libh__r;						\
	libh__dt = lldiv( (x), (y) );						\
	libh__q = (q);								\
	if ( libh__q ) * libh__q = libh__dt.quot;				\
	libh__r = (r);								\
	if ( libh__r ) * libh__r = libh__dt.rem;				\
	0;									\
})

__FMACRO_END__
