//-----------------------------------------------------------------------------
// Copyright  2006 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/ftr
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#define _GNU_SOURCE

#include "ftr_lib.h"

#include <fcntl.h>
#include <limits.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

__PROTO_BEGIN__
//-----------------------------------------------------------------------------
// function	ftr_skip_dir
//
// purpose	Skip the descent into the most recently descended directory
//		that has not yet been ascended.
//
// note		The next return from ftr_get() should be the ascending state.
//
// arguments	1 (FTR) reference to which file tree recursion.
//
// returns	(int)  < 0 : error
//		(int) == 0 : success
//-----------------------------------------------------------------------------
int
ftr_skip_dir (
    FTR			arg_ftr
    )
__PROTO_END__
{
    if ( ! arg_ftr ) return -1;
    if ( ! arg_ftr->curr_dir ) return 0;
    return avl_empty( & ( arg_ftr->curr_dir->name_tree ), free );
}
