//-----------------------------------------------------------------------------
// Copyright  2006 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/helloworld
// homepage	http://phil.ipal.org/freeware/libh/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <libh/ftr.h>
#include <libh/string.h>

//-----------------------------------------------------------------------------
// program	ftr-bin-cmd
//
// purpose	Scan the "bin" and "cmd" directories in sequence to test the
//		ftr_new_va() function.
//
// syntax	ftr-bin-cmd
//
// returns	(int) >= 0 : success
//		(int) == EOF : error
//-----------------------------------------------------------------------------
int
main (
    int		argc
    ,
    char * *	argv
    ,
    char * *	envp
    )
{
    FTR		this_ftr	;
    char *	pgm		;
    int		ftype		;

    pgm = str_tail_one( argv[0], '/' );
    this_ftr = ftr_new_va( "bin", "cmd" );
    if ( ! this_ftr ) {
	fprintf( stderr, "%s: ftr_new_va( \"bin\", \"cmd\" ) fails: %s\n", pgm, strerror( errno ) );
	return 1;
    }
    while ( ( ftype = ftr_get( this_ftr ) ) > 0 ) {
	switch ( ftype ) {
	case 'a':
	case 'b': case 'c': case 'd': case 'f': case 'l': case 'p': case 's':
	    fputc( ftype, stdout );
	    fputc( ' ', stdout );
	    fputs( ftr_name_full( this_ftr ), stdout );
	    fputc( '\n', stdout );
	    fflush( stdout );
	}
    }
    ftr_end( this_ftr );

    return 0;
}
