__PREFIX_BEGIN__
//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307	 USA
//-----------------------------------------------------------------------------
// package	libh/http
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// file		http.h
//
// purpose	Define resources used by and with the http library.
//-----------------------------------------------------------------------------
#ifndef __HTTP_H__
#define __HTTP_H__

__PREFIX_END__

__INCLUDE_BEGIN__
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <libh/time.h>

__INCLUDE_END__

__DEFINE_BEGIN__
//-----------------------------------------------------------------------------
// Define HTTP response strings.
//-----------------------------------------------------------------------------
#define HTTP_RESPONSE_100	"100 Continue"
#define HTTP_RESPONSE_101	"101 Switching Protocols"
#define HTTP_RESPONSE_102	"102 Processing"

#define HTTP_RESPONSE_200	"200 OK"
#define HTTP_RESPONSE_201	"201 Created"
#define HTTP_RESPONSE_202	"202 Accepted"
#define HTTP_RESPONSE_203	"203 Non-Authoritative Information"
#define HTTP_RESPONSE_204	"204 No Content"
#define HTTP_RESPONSE_205	"205 Reset Content"
#define HTTP_RESPONSE_206	"206 Partial Content"
#define HTTP_RESPONSE_207	"207 Multi-Status"

#define HTTP_RESPONSE_300	"300 Multiple Choices"
#define HTTP_RESPONSE_301	"301 Moved Permanently"
#define HTTP_RESPONSE_302	"302 Found"
#define HTTP_RESPONSE_303	"303 See Other"
#define HTTP_RESPONSE_304	"304 Not Modified"
#define HTTP_RESPONSE_305	"305 Use Proxy"
#define HTTP_RESPONSE_307	"307 Temporary Redirect"

#define HTTP_RESPONSE_400	"400 Bad Request"
#define HTTP_RESPONSE_401	"401 Unauthorized"
#define HTTP_RESPONSE_402	"402 Payment Required"
#define HTTP_RESPONSE_403	"403 Forbidden"
#define HTTP_RESPONSE_404	"404 Not Found"
#define HTTP_RESPONSE_405	"405 Method Not Allowed"
#define HTTP_RESPONSE_406	"406 Not Acceptable"
#define HTTP_RESPONSE_407	"407 Proxy Authentication Required"
#define HTTP_RESPONSE_408	"408 Request Timeout"
#define HTTP_RESPONSE_409	"409 Conflict"
#define HTTP_RESPONSE_410	"410 Gone"
#define HTTP_RESPONSE_411	"411 Length Required"
#define HTTP_RESPONSE_412	"412 Precondition Failed"
#define HTTP_RESPONSE_413	"413 Request Entity Too Large"
#define HTTP_RESPONSE_414	"414 Request-URI Too Long"
#define HTTP_RESPONSE_415	"415 Unsupported Media Type"
#define HTTP_RESPONSE_416	"416 Requested Range Not Satisfiable"
#define HTTP_RESPONSE_417	"417 Expectation Failed"
#define HTTP_RESPONSE_422	"422 Unprocessable Entity"
#define HTTP_RESPONSE_423	"423 Locked"
#define HTTP_RESPONSE_424	"424 Failed Dependency"

#define HTTP_RESPONSE_500	"500 Internal Server Error"
#define HTTP_RESPONSE_501	"501 Not Implemented"
#define HTTP_RESPONSE_502	"502 Bad Gateway"
#define HTTP_RESPONSE_503	"503 Service Unavailable"
#define HTTP_RESPONSE_504	"504 Gateway Timeout"
#define HTTP_RESPONSE_505	"505 HTTP Version Not Supported"
#define HTTP_RESPONSE_506	"506 Variant Also Negotiates"
#define HTTP_RESPONSE_507	"507 Insufficient Storage"
#define HTTP_RESPONSE_510	"510 Not Extended"

__DEFINE_END__

__SUFFIX_BEGIN__
#endif /* __HTTP_H__ */
__SUFFIX_END__
