//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/http
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	phil at ipal dot org
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 112 columns wide.
//-----------------------------------------------------------------------------

#include "http_lib.h"

__PROTO_BEGIN__
//-----------------------------------------------------------------------------
// function	http_no_cache
//
// purpose	Output headers for a page with no caching.
//
// arguments	-none-
//
// returns	(int) 0
//-----------------------------------------------------------------------------
int
http_no_cache ()
    __PROTO_END__
{
    //-- If HTTP is already done, return an error.
    if ( http_done ) return -1;

    //-- Output headers to turn off caching.
    http_date_now();
    http_date( 0, "Expires", 0 );
    http_date( 0, "Last-modified", 0 );
    http_header( 0, "Cache-Control", "private", NULL );
    http_header( 0, "Cache-Control", "no-transform", NULL );
    http_header( 0, "Cache-Control", "no-cache", NULL );
    http_header( 0, "Pragma", "no-cache", NULL );

    return 0;
}
