//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/io
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "io_lib.h"

__PROTO_BEGIN__
//-----------------------------------------------------------------------------
// macro	close_all_between
//
// purpose	Mass close file descriptors between given values, inclusively.
//
// arguments	1 (int) first file descriptor to close
//		2 (int) last file descriptor to close
//
// returns	(int) number of descriptors closed successfully
//-----------------------------------------------------------------------------
#define close_all_between(first,last) ({					\
	int libh__this_fd;							\
	int libh__last_fd;							\
	int libh__count;							\
	libh__this_fd = (first);						\
	libh__last_fd = (last);							\
	while ( libh__this_fd <= libh__last_fd ) {				\
		if ( close( libh__this_fd ) == 0 ) ++ libh__count; 		\
	}									\
	libh__count;								\
})
