//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307	 USA
//-----------------------------------------------------------------------------
// package	libh/io
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include <stdarg.h>
#include <stdio.h>

#include "io_lib.h"


__PROTO_BEGIN__
//-----------------------------------------------------------------------------
// function	msg_vprintf
//
// purpose	Format an output message according to registered and given
//		format specifications and output it to stdout.
//
// arguments	1 (const char *) format for message content
//		2 (va_list) started variable argument list
//
// returns	(int) number of characters printed
//-----------------------------------------------------------------------------
int
msg_vprintf (
    const char *	arg_format
    ,
    va_list		arg_va_list
    )
    __PROTO_END__
{
    return msg_vfprintf( stdout, arg_format, arg_va_list );
}
