//-----------------------------------------------------------------------------
// Copyright  2006 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/io
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	stat_mode_join
//
// purpose	Return mode of a file where the file name is given as
//		multiple string arguments to be joined together.
//
// arguments	1..N (const char *) file name parts
//
// returns	(mode_t) == -1 : [failure, see errno]
//		(mode_t) >=  0 : [success] file mode
//-----------------------------------------------------------------------------
#define stat_mode_join(f...) ({							\
	struct stat libh__statbuf;						\
	stat_join( & libh__statbuf, f ) < 0					\
		? (mode_t) -1							\
		: libh__statbuf.st_mode;					\
})

__FMACRO_END__
