//-----------------------------------------------------------------------------
// Copyright  2006 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/io
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "io_lib.h"

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	stat_size
//
// purpose	Return size of a file.
//
// arguments	1 (const char *) file name
//
// returns	(long long) == -1 : [failure, see errno]
//		(long long) >=  0 : [success] file size
//
// note		A (long long) type is returned so that if type (off_t) is a
//		smaller unsigned integer, it's full range of values will not
//		collide with the error return value.
//-----------------------------------------------------------------------------
#define stat_size(f) ({								\
	struct stat libh__statbuf;						\
	stat( (f), & libh__statbuf ) < 0					\
		? (long long) -1						\
		: (long long) libh__statbuf.st_size;				\
})

__FMACRO_END__
