//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/io
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_END__
//-----------------------------------------------------------------------------
// macro	unlock_file
//
// purpose	Simple interface to POSIX fcntl() file/record/range locking.
//		Unlock all locks on this record of this file.
//
// arguments	1 (int) file descriptor of open file to unlock
//		2 (off_t) starting byte offset to record/range to unlock
//		3 (off_t) length of record/range to unlock
//
// returns	(int) -1 : error
//		(int)  0 : unlock successful
//-----------------------------------------------------------------------------
#define unlock_file(f,s,l) ({							\
	struct flock libh__lock;						\
	libh__lock.l_type = ( F_UNLCK );					\
	libh__lock.l_whence = ( SEEK_SET );					\
	libh__lock.l_start = ( s );						\
	libh__lock.l_len = ( l );						\
	fcntl( ( f ), ( F_SETLK ), & libh__lock );				\
	})

__FMACRO_END__
