//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/io
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// program	scan_config_item
//
// purpose	Scan a config file item by item and report contents.
//
// syntax	scan_config_item < config_file
//-----------------------------------------------------------------------------
#include <stdio.h>

#include <libh/io.h>

//-----------------------------------------------------------------------------
// function	main
//-----------------------------------------------------------------------------
int
main (
    int		argc
,
    char * *	argv
)
{
    char	name		[256];
    char	data		[4096];
    size_t	name_len	;
    size_t	data_len	;
    int		nest		;
    int		state		;
    int		trunc		;
    int		i		;

    nest = 0;

    for (;;) {

	state = get_config_item( name, 256, & name_len, data, 4096, & data_len, stdin, & trunc );

	if ( state == 1 ) {

	    for (i=0;i<nest;++i) printf( "\t" );
	    printf( "name = \"%s\" (name_len=%Zu)  (no data)\n", name, name_len );
	    put_config_item( name, name_len, NULL, 0, stdout );

	} else if ( state == 2 ) {

	    for (i=0;i<nest;++i) printf( "\t" );
	    printf( "name = \"%s\" (name_len=%Zu)  data = \"%s\" (data_len=%Zu)\n", name, name_len, data, data_len );
	    put_config_item( name, name_len, data, data_len, stdout );

	} else break;

    }

    return 0;
}
