//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/io
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include <errno.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>

#include <libh/io.h>

//-----------------------------------------------------------------------------
// program	test_proc_read
// purpose	Test the fopen_proc() and open_proc() functions.
// syntax	test_proc_read command [ arguments ]
//-----------------------------------------------------------------------------
int
main (
    int		argc
    ,
    char * *	argv
    )
{
    FILE *	file_read	;
    int		ch		;

    if ( argc <= 1 || ! argv[1] ) {
	fprintf( stderr, "syntax:  test_proc_read command [ arguments ]\n" );
	return 1;
    }

    file_read = fopen_proc( "re", argv[1], argv+1 );
    if ( ! file_read ) {
	fprintf( stderr, "error %d calling fopen_proc(): %s\n", errno, strerror( errno ) );
	return 1;
    }

    while ( ( ch = fgetc( file_read ) ) != EOF ) {
	fputc( ch, stdout );
	fflush( stdout );
    }

    fclose( file_read );
    fclose( stdout );

    return 0;
}
