//-----------------------------------------------------------------------------
// Copyright  2012 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/keepstr
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// file		keepstr_lib.h
//
// purpose	Define resources used by the keepstr library.
//-----------------------------------------------------------------------------
#ifndef __KEEPSTR_LIB_H__
#define __KEEPSTR_LIB_H__

//-----------------------------------------------------------------------------
// headers
//-----------------------------------------------------------------------------

#define _GNU_SOURCE

#include "libh_common.h"
#include "libh/avl.h"

#include <string.h>

//-----------------------------------------------------------------------------
// structs
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// struct       keepstr_s
//
// purpose      Hold one string in the keepstr pool.
//-----------------------------------------------------------------------------
struct keepstr_s {
    avl_link    link            ;
    char        str     [1]     ;
};
typedef struct keepstr_s        keepstr_t       ;
typedef struct keepstr_s *      keepstr_p       ;

//-----------------------------------------------------------------------------
// end header
//-----------------------------------------------------------------------------

#endif /* __KEEPSTR_LIB_H__ */
