//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/map
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// file		map_free_node.c
//-----------------------------------------------------------------------------

#include "map_lib.h"

#if 0
//-----------------------------------------------------------------------------
// struct	map_link
// struct	map_node
//
// purpose	Define structures needed to keep the AVL trees used to hold
//		the mapping.
//-----------------------------------------------------------------------------
struct map_link {
    avl_link		link	;
    // The key is found here in the type specific structs.
};
struct map_node {
    struct map_mixed	data	;
    struct map_link	link	;
};
#endif

__PROTO_BEGIN__
//-----------------------------------------------------------------------------
// function	map_free_node (internal)
//
// purpose	Free a node, including data content where applicable.  Since
//		it is not necessary to know the node or data size in order to
//		free it, this code only needs to get the pointers for freeing.
//
// arguments	1 (void *) pointer to variant node type
//
// returns	(void)
//-----------------------------------------------------------------------------
void
map_free_node (
    void *	arg_node
    )
__PROTO_END__
{
    struct map_node *	node_p	;

    node_p = arg_node;

    //-- If the data is another mapping, destroy it.
    if ( node_p->data.type == MAP_DATA_MAP ) {
	map_destroy( node_p->data.mix.scalar.map );
    }

    //-- Else if the data was an array/string, delete that.
    else if ( map_type_is_string( node_p->data.type ) && node_p->data.mix.array.dup ) {
	free( node_p->data.mix.array.ptr );
    }

    //-- Free the node itself, with key.
    free( node_p );

    return;
}
