//---------------------------------------------------------------------------------------------------
// Copyright  2012 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//---------------------------------------------------------------------------------------------------
// package	libh/mstr
// homepage	http://libh.slashusr.org/
//---------------------------------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//---------------------------------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//---------------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------------
// file		mstr_lib.h
//
// purpose	Define resources used by the mstr library.
//---------------------------------------------------------------------------------------------------
#ifndef __MSTR_LIB_H__
#define __MSTR_LIB_H__

//---------------------------------------------------------------------------------------------------
// headers
//---------------------------------------------------------------------------------------------------
#define _GNU_SOURCE

#include "libh_common.h"

#include "libh/avl.h"
#include "libh/keepstr.h"
#include "libh/mstr.h"

#include <stdarg.h>
#include <stddef.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

//---------------------------------------------------------------------------------------------------
// types
//---------------------------------------------------------------------------------------------------
typedef signed int		mstr_si		;
typedef unsigned int		mstr_ui		;
typedef int32_t			mstr_s32	;
typedef uint32_t		mstr_u32	;
typedef signed long		mstr_sl		;
typedef unsigned long		mstr_ul		;
typedef int64_t			mstr_s64	;
typedef uint64_t		mstr_u64	;
typedef signed long long	mstr_sll	;
typedef unsigned long long	mstr_ull	;

#ifdef HAVE_INT128
typedef int128_t		mstr_s128	;
typedef uint128_t		mstr_u128	;
#endif

typedef intptr_t		mstr_sp		;
typedef uintptr_t		mstr_up		;
typedef intmax_t		mstr_sm		;
typedef uintmax_t		mstr_um		;

typedef float			mstr_f		;
typedef double			mstr_d		;
typedef long double		mstr_ld		;

typedef void *			mstr_p		;
typedef size_t			mstr_s		;

union mstr_ip4 {
    uint8_t		ip4_8		[4]	;
    uint16_t		ip4_16		[2]	;
    uint32_t		ip4_32		[1]	;
};
typedef union mstr_ip4		mstr_ip4	;

union mstr_ip6 {
    uint8_t		ip6_8		[16]	;
    uint16_t		ip6_16		[8]	;
    uint32_t		ip6_32		[4]	;
    uint64_t		ip6_64		[2]	;
#ifdef HAVE_INT128
    uint128_t		ip6_128		[1]	;
#endif
};
typedef union mstr_ip6		mstr_ip6	;
										 
//---------------------------------------------------------------------------------------------------
// end header
//---------------------------------------------------------------------------------------------------

#endif /* __MSTR_LIB_H__ */
