//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/net
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	hbo_to_sockaddr_in
//
// purpose	Combine port and address in host byte order to make a struct
//		sockaddr_in to be assigned to a target lvalue.
//
// arguments	1 (unsigned long) address in host byte order
//		2 (unsigned int) port number in host byte order
//
// returns	(struct sockaddr_in) yielded struct
//-----------------------------------------------------------------------------
#define hbo_to_sockaddr_in(a,p) ({						\
	struct sockaddr_in	libh__addr;					\
	memset( & libh__addr, 0, sizeof libh__addr );				\
	libh__addr.sin_family = AF_INET;					\
	libh__addr.sin_port = htons( (p) );					\
	libh__addr.sin_addr.s_addr = htonl( (a) );				\
	libh__addr;								\
})

__FMACRO_END__
