//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/net
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	ipv4_addr_in_cidr
//
// purpose	Yield true or false indicating if the specified IP address is
//		in the CIDR block specified by address and prefix length.
//
// arguments	1 (ipv4_t) address to define CIDR block
//		2 (int) prefix length (1..32)
//		3 (ipv4_t) address to check
//
// yields	(int) true or false
//-----------------------------------------------------------------------------
#define ipv4_addr_in_cidr(n,p,a) ((((~(ipv4_t)0)<<(32-(p)))&(n))==(((~(ipv4_t)0)<<(32-(p)))&(a)))

__FMACRO_END__
