//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/net
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	ipv4_addrprefix_to_netbase
//
// purpose	Convert an IPv4 address plus network prefix length into a
//		network base address.
//
// arguments	1 (ipv4_t) IPv4 address value in integer form
//		2 (unsigned int) network prefix length (0..32)
//
// returns	(ipv4_t) IPv4 network base address
//
// note		There are no possible error indications from this function.
//		If the network prefix length is out of range, results are
//		undefined.
//-----------------------------------------------------------------------------
#define ipv4_addrprefix_to_netbase(a,p)						\
	(((ipv4_t)(a))&((~(ipv4_t)0U)<<(32U-((unsigned int)(p)))))

__FMACRO_END__
