//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/net
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	ipv4_combine_octets
//
// purpose	Combine an IPv4 address in four separate octet parts into a
//		single 32-bit integer result.
//
// arguments	1 (ipv4_t) highest order octet
//		2 (ipv4_t) second highest order octet
//		3 (ipv4_t) second lowest order octet
//		4 (ipv4_t) lowest order octet
//
// returns	(ipv4_t) one complete IPv4 address
//
// note		This macro assumes the given octets are already limited to
//		values in the range 0..255.  If they are outside this range,
//		the results are undefined.
//-----------------------------------------------------------------------------
#define ipv4_combine_octets(a,b,c,d)						\
	((((ipv4_t)(a))<<24)|(((ipv4_t)(b))<<16)|(((ipv4_t)(c))<<8)|((ipv4_t)(d))<<0)

__FMACRO_END__
