//-----------------------------------------------------------------------------
// Copyright  2005 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/string
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "net_lib.h"

__DEFINE_BEGIN__
//-----------------------------------------------------------------------------
// struct	ipv4_table_node
// typedef	ipv4_table_node_p
//
// purpose	This is a node struct of an IPv4 lookup table.
//-----------------------------------------------------------------------------
struct ipv4_table_node {
    struct ipv4_table_node *	next	[2]	;
    struct ipv4_table_node *	prev		;
    struct ipv4_table_node *	data		;
};
typedef struct ipv4_table_node *	ipv4_table_node_p	;

//-----------------------------------------------------------------------------
// struct	ipv4_table
// typedef	ipv4_table_p
//
// purpose	This is the head struct of an IPv4 lookup table, including
//		the apex node itself.
//-----------------------------------------------------------------------------
struct ipv4_table {
    struct ipv4_table_node	apex		;
    struct ipv4_table_node *	last		;
    int				prefix		;
};
typedef struct ipv4_table *		ipv4_table_p		;

__DEFINE_END__
