//-----------------------------------------------------------------------------
// Copyright  2005 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/string
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "net_lib.h"

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	ipv4_table_destroy
//
// purpose	Destroy an instance of an IPv4 lookup table.
//
// arguments	1 (ipv4_table_p) pointer to table to destroy
//
// returns	(void)
//-----------------------------------------------------------------------------
#define ipv4_table_destroy(t) ({						\
	ipv4_table_p libh__table_p;						\
	libh__table_p = (t);							\
	if ( libh__table_p ) {							\
		ipv4_table_empty_node( & libh__table_p->apex, 32 );		\
		libh__table_p->apex.next[0] = NULL;				\
		libh__table_p->apex.next[1] = NULL;				\
		libh__table_p->apex.prev = NULL;				\
		libh__table_p->apex.data = NULL;				\
		libh__table_p->last = NULL;					\
		libh__table_p->prefix = 0;					\
		free( libh__table_p );						\
	}									\
})
