//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/net
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	nbo_to_sockaddr_in6
//
// purpose	Combine port and address in network byte order to make a struct
//		sockaddr_in to be assigned to a target lvalue.
//
// arguments	1 (struct sin6_addr) address in network byte order
//		2 (u_int16_t) port number in network byte order
//
// returns	(struct sockaddr_in6) yielded struct
//-----------------------------------------------------------------------------
#define nbo_to_sockaddr_in6(a,p) ({						\
	struct sockaddr_in6	libh__addr;					\
	libh__addr.sin6_family = AF_INET6;					\
	libh__addr.sin6_port = (p);						\
	libh__addr.sin6_addr = (a);						\
	libh__addr;								\
})

__FMACRO_END__
