//-----------------------------------------------------------------------------
// Copyright  2010 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/optplus
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "optplus_lib.h"

__PROTO_BEGIN__
//---------------------------------------------------------------------------------------------------
// function	optplus_end
//
// purpose	End and destroy an option scanning object.
//
// argument	1 (optplus_p) pointer to option scanning object
//
// returns	(int) == -1 : error
//		(int) ==  0 : OK
//---------------------------------------------------------------------------------------------------
int
optplus_end (
    optplus_p	this_optplus
    )
__PROTO_END__
{
    if ( ! this_optplus ) return -1;
    this_optplus->arga = NULL;
    this_optplus->argt = NULL;
    this_optplus->argx = NULL;
    this_optplus->argz = NULL;
    free( this_optplus );
    return 0;
}
