//-----------------------------------------------------------------------------
// Copyright  2010 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/optplus
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "optplus_lib.h"

__PROTO_BEGIN__
//---------------------------------------------------------------------------------------------------
// function	optplus_new
//
// purpose	Create a new option scanning object, initialized with the
//		given argument parameters.
//
// arguments	1 (int) argument list count
//		2 (const char * const *) argument list pointer
//
// returns	(optplus_p) == NULL : error (probably out of memory)
//		(optplus_p) != NULL : pointer to new option scanning object
//---------------------------------------------------------------------------------------------------
optplus_p
optplus_new (
    int				argc
    ,
    const char * const *	argv
    )
__PROTO_END__
{
    optplus_p	this_optplus	;

    this_optplus = malloc( sizeof (struct optplus_s) );
    if ( this_optplus ) {
	this_optplus->arga		= argv;
	this_optplus->argt		= argv;
	this_optplus->argx		= argv;
	this_optplus->argz		= argv + argc;
	this_optplus->char_ptr		= NULL;
	this_optplus->name_str		= NULL;
	this_optplus->value_str		= NULL;
	this_optplus->name_end		= NULL;
	this_optplus->value_end		= NULL;
	this_optplus->name_len		= 0;
	this_optplus->value_len		= 0;
	this_optplus->count		= 0;
	this_optplus->type		= 0;
	this_optplus->char_code[0]	= 0;
	this_optplus->char_code[1]	= 0;
	this_optplus->pre_char[0]	= 0;
	this_optplus->pre_char[1]	= 0;
	this_optplus->pre_char[2]	= 0;
    }
    return this_optplus;
}
