//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package      libh/strapp
// homepage http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author       Philip Howard
// email        libh at ipal dot org
// homepage     http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>

#include <libh/string.h>

#define WORDSIZE	512

//-----------------------------------------------------------------------------
// program	numtext
//
// purpose	Convert a number on the command line to a string of text in
//		US English.  This is principly for use in shell scripts.
//-----------------------------------------------------------------------------
int
main (
    int		argc
,
    char * *	argv
)
{
    while ( -- argc && ++ argv ) {
	unsigned long long num;
	char * argp;
	char words[WORDSIZE];

	argp = * argv;
	words[0] = 0;

	num = str_expr_to_ull( argp, NULL, 0 );
	str_app_ull_text( words, WORDSIZE, num, "en_US" );
	puts( words );
    }

    return 0;
}
