//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package      libh/string
// homepage http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author       Philip Howard
// email        libh at ipal dot org
// homepage     http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <libh/string.h>

//-----------------------------------------------------------------------------
// program	strrep
//
// purpose	Replace a pattern string with a replacement string for each
//		occurrence in a source string.
//
// syntax	strrep "pattern" "replacement" source string with pattern
//-----------------------------------------------------------------------------
int
main (
    int		argc
,
    char * *	argv
)
{
    char	target_str	[4096];
    int		n		;

    if ( argc <= 3 ) {
	fprintf( stderr, "syntax \"pattern\" \"replacement\" source string with pattern\n" );
	return 1;
    }

    target_str[0] = 0;

    for ( n = 3; n < argc; ++ n ) {
	if ( n > 3 ) str_app_ch( target_str, 4096, ' ' );
	str_app_rep( target_str, 4096, argv[1], argv[2], argv[n] );
    }

    puts( target_str );

    return 0;
}
