//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package      libh/string
// homepage http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author       Philip Howard
// email        libh at ipal dot org
// homepage     http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <libh/string.h>

//-----------------------------------------------------------------------------
// program	strsub
//
// purpose	Extract a substring based on indexed parts between a
//		separator string.
//
// syntax	strsub beginindex endindex separator sourcestring
//-----------------------------------------------------------------------------
int
main (
    int		argc
,
    char * *	argv
)
{
    const char *	separator	;
    const char *	sourcestring	;

    signed long		beginindex	;
    signed long		endindex	;

    char		target_str	[4096];

    if ( argc <= 4 ) {
	fprintf( stderr, "syntax: strsub beginindex endindex separator sourcestring\n" );
	return 1;
    }

    separator    = argv[1];
    beginindex   = str_expr_to_sl( argv[2], NULL, 0 );
    endindex     = str_expr_to_sl( argv[3], NULL, 0 );
    sourcestring = argv[4];

    target_str[0] = 0;

    str_app_sub( target_str, 4096, beginindex, endindex, sourcestring, separator );

    puts( target_str );

    return 0;
}
