//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package      libh/string
// homepage http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author       Philip Howard
// email        libh at ipal dot org
// homepage     http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <libh/string.h>

//-----------------------------------------------------------------------------
// program	tld
// alias	sld
//
// purpose	Strip a fully qualified domain name down to it's TLD or SLD.
//-----------------------------------------------------------------------------
int
main (
    int		argc
,
    char * *	argv
)
{
    char *	tail	;
    char *	tld	;
    char *	sld	;

    if ( argc <= 1 ) return 1;

    tail = str_tail( argv[0], '/', 1 );
    tld = str_tail( argv[1], '.', 1 );
    sld = str_tail( argv[1], '.', 2 );

    if ( tolower( tail[0] ) == 't' ) puts( tld );
    if ( tolower( tail[0] ) == 's' ) puts( sld );

    return 0;
}
