//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/string
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	mem_dup_ptr_ptr
//
// purpose	Duplicate into allocated space the contents of one string of
//		bytes beginning where the first pointer points to and ending
//		just before where the second pointer pounts to.
//
// arguments	1 (const char *) pointer to where string begins
//		2 (const char *) pointer to where string ends
//
// returns	(char *) new allocated duplicate string, caller must free
//-----------------------------------------------------------------------------
#define mem_dup_ptr_ptr(ptr,end) ({						\
	const char * libh__ptr = ( ptr );					\
	const char * libh__end = ( end );					\
	size_t libh__len = libh__end - libh__ptr;				\
	char * libh__new = malloc( libh__len + 1 );				\
	if ( libh__new ) {							\
		memcpy( libh__new, libh__ptr, libh__len );			\
		libh__new[ libh__len ] = 0;					\
	}									\
	libh__new;								\
})

__FMACRO_END__
