//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/string
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "string_lib.h"

__PROTO_BEGIN__
//-----------------------------------------------------------------------------
// function	mem_upper
//
// purpose	Convert each character in a string specified by pointer and
//		length to its upper case equivalent within the same string.
//
// arguments	1 (char *) pointer to target string to convert
//		2 (size_t) length to convert
//
// returns	(size_t) length of string, or ~0 for error
//-----------------------------------------------------------------------------
size_t
mem_upper (
    char *		arg_target
    ,
    size_t		arg_length
    )
__PROTO_END__
{
    char *	ptr	;

    if ( ! arg_target ) return ~0;
    ptr = arg_target;
    while ( -- arg_length ) {
	* ptr = toupper( * ptr );
	++ ptr;
    }
    return ptr - arg_target;
}
