//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/string
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	str_cpy_lim
//
// purpose      Copy to the first string (given with maximum available space)
//              the contents of another string limited by number of characters.
//
//              Do copy only if all source strings can be copied, else make
//              target string empty.
//
// arguments    1 (char *) pointer to target string
//              2 (size_t) maximum space in target string
//              3 (const char *) source string to copy
//              4 (size_t) limit length of source string
//
// returns      (size_t) new length of string, or ~0 for error
//-----------------------------------------------------------------------------
#define str_cpy_lim(t,m,s,l) (str_empty((t)),str_app_lim((t),(m),(s),(l)))

__FMACRO_END__
