//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/string
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	str_cpy_part_space
//
// purpose	Copy to the target string given with maximum available space
//		the first item found in the source string separated by a space
//		character, returning a pointer to the remainder of the source.
//
//		If the string to be copied does not fit the available space,
//		it remains truncated without indication.
//
//		Unlike str_split_space(), this function does not modify the
//		source string.
//
// arguments	1 (char *) pointer to target string
//		2 (size_t) maximum space in target string
//		3 (const char *) input string
//
// returns	(char *) NULL : no item found or error
//		(char *) pointer to remainder in input string.
//
// note		Spaces are determined according to the isspace() macro or
//		function in the C language.  Multiple space characters in a
//		group constitute a single delimiter, even if mixed.
//
// note		Any leading spaces will be removed.  If the caller needs to
//		know if there were any leading spaces, it should check the
//		original string first with isspace().
//-----------------------------------------------------------------------------
#define str_cpy_part_space(t,l,s) (str_empty((t)),str_app_part_space((t),(l),(s)))

__FMACRO_END__
