//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/string
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	str_cpy_rep
//
// purpose	Copy to the target string the contents of the source string,
//		with all occurrences of the pattern string replaced by the
//		replacement string.
//
//		If entire resultant string will not fit the available space,
//		then rollback everything leaving the original target empty.
//
// arguments	1 (char *) pointer to beginning of target string
//		2 (size_t) total maximum length of target string
//		3 (const char *) pattern string to be matched in source
//		4 (const char *) replacement string to replace each pattern
//		5 (const char *) source string to be appended to target
//
// returns	(size_t) final length of target string
//		(size_t) ~0 : error
//
// note		Contents of target string space will be overwritten if there
//		is insufficient space to complete the copy.  Nothing should
//		be stored there, anyway.
//-----------------------------------------------------------------------------
#define str_cpy_rep(t,l,p,r,s) (str_empty((t)),str_app_rep((t),(l),(p),(r),(s)))

__FMACRO_END__
