//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/string
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	str_cpy_url
//
// purpose      Copy to the first string (given with maximum available space)
//              a URL formed from several component strings.
//
// arguments    1 (char *) pointer to target string
//              2 (size_t) maximum space in target string
//              3 (const char *) protocol, "http", "ftp"
//              4 (const char *) username
//              5 (const char *) password
//              6 (const char *) hostname
//              7 (const char *) portnum
//              8 (const char *) fullpath
//              9 (const char *) querystring
//
// returns      (size_t) length of string, or ~0 for error
//-----------------------------------------------------------------------------
#define str_cpy_url(t,l,a,b,c,d,e,f,g) (str_empty((t)),str_app_url((t),(l),(a),(b),(c),(d),(e),(f),(g)))

__FMACRO_END__
