//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/string
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	str_tail_one
//
// purpose	Select one component of the tail of a string and return a
//		pointer with the result.
//
// arguments	1 (const char *) string to extract tail from
//		2 (int) the delimiter character code
//
// returns	(char *) returned pointer
//-----------------------------------------------------------------------------
#define str_tail_one(s,d) ({							\
	__typeof__(*(s)) *libh__str;						\
	__typeof__(*(s)) *libh__ptr;						\
	int libh__del;								\
	libh__ptr = libh__str = (__typeof__(libh__str)) (s);			\
	while ( * libh__ptr ) ++ libh__ptr;					\
	libh__del = (d);							\
	while ( -- libh__ptr >= libh__str && * libh__ptr != libh__del );	\
	libh__ptr + 1;								\
})

__FMACRO_END__
