//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/string
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "string_lib.h"

__PROTO_BEGIN__
//-----------------------------------------------------------------------------
// function	str_truncate
//
// purpose	Truncate a null terminated string to a specified length if it
//		is longer than that length.
//
// arguments	1 (char *) pointer to string to truncate
//		2 (size_t) length to truncate string to
//
// returns	(size_t) new length of string, or ~0 for error
//
// note		If the string is shorter that the requested length, then the
//		string remains the same length.
//-----------------------------------------------------------------------------
size_t
str_truncate (
    char *		arg_target
    ,
    size_t		arg_length
    )
__PROTO_END__
{
    char *		ptr		;
    size_t		len		;

    //-- Determine end of string and truncate by placing null character.
    ptr = arg_target;
    len = arg_length;
    while ( len -- && * ptr ) ++ ptr;
    * ptr = 0;
    return ptr - arg_target;
}
