//-----------------------------------------------------------------------------
// Copyright  2003 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/string
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include <errno.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>

#include <libh/string.h>


//-----------------------------------------------------------------------------
// program	numencode
//
// purpose	Test the str_app_ld_encode function.
//
// syntax	numencode first step last
//-----------------------------------------------------------------------------
int
main (
    int		argc
    ,
    char * *	argv
    )
{
    long double		first	;
    long double		step	;
    long double		last	;
    long double		value	;

    char		space	[256]	;

    if ( argc <= 3 ) {
	fprintf( stderr, "numencode  first step last\n" );
	return 1;
    }

    first = str_expr_to_ld( argv[1], NULL );
    step  = str_expr_to_ld( argv[2], NULL );
    last  = str_expr_to_ld( argv[3], NULL );

#if 0
    printf( "from %Lg by %Lg to %Lg\n",first,step,last);
#endif

    if ( step < 0.0 ) {
	for ( value = first; value >= last; value += step ) {
	    space[0] = 0;
	    str_app_ld_cet( space, 256, value );
	    printf( "%32.24Lf (%21.15La) = %s\n", value, value, space );
	}
    } else if ( step > 0.0 ) {
	for ( value = first; value <= last; value += step ) {
	    space[0] = 0;
	    str_app_ld_cet( space, 256, value );
	    printf( "%32.24Lf (%21.15La) = %s\n", value, value, space );
	}
    }

    return 0;
}
