//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/time
// purpose	Support daemon startup
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	current_strftime_gmt
//
// purpose	Format the current gmt time via strftime formatting.
//
// arguments	1 (char *) where to put the result formatted string
//		2 (size_t) size of space to put the result string
//		3 (const char *) format string
//
// returns	(size_t) number of characters placed into result string
//
// note		This macro uses the reentrant and thread safe gmtime_r().
//-----------------------------------------------------------------------------
#define current_strftime_gmt(m,s,f) ({						\
	struct tm	libh__tm;						\
	time_t		libh__time;						\
	libh__time = time( NULL );						\
	gmtime_r( (time_t *) & libh__time, & libh__tm );			\
	strftime( (m), (s), (f), & libh__tm );					\
})

__FMACRO_END__
