//-----------------------------------------------------------------------------
// Copyright  2009 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/time
// purpose	Support daemon startup
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	current_strftime_usec_local
//
// purpose	Format the current local time via strftime formatting.
//
// arguments	1 (char *) where to put the result formatted string
//		2 (size_t) size of space to put the result string
//		3 (const char *) format string
//		4 (const char *) format for microseconds
//
// returns	(size_t) number of characters placed into result string
//
// note		This macro uses the reentrant and thread safe localtime_r().
//-----------------------------------------------------------------------------
#define current_strftime_usec_local(m,s,f,u) ({					\
	struct timeval	libh__tv;						\
	struct tm	libh__tm;						\
	char *		libh__ptr;						\
	size_t		libh__size;						\
	size_t		libh__len;						\
	libh__ptr = (m);							\
	libh__size = (s);							\
	gettimeofday( & libh__tv, NULL );					\
	localtime_r( (time_t *) & libh__tv.tv_sec, & libh__tm );		\
	libh__len = strftime( libh__ptr, libh__size, (f), & libh__tm );		\
	if ( libh__len > 0 ) {							\
		libh__ptr += libh__len;						\
		libh__size -= libh__len;					\
		libh__len += snprintf( libh__ptr, libh__size, (u), (unsigned long) libh__tv.tv_usec );	\
	}									\
	libh__len;								\
})

__FMACRO_END__
