//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/time
// purpose	Support daemon startup
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	current_timeus
//
// purpose	Get the current time in microseconds as a 64 bit integer.
//
// arguments	-none-
//
// returns	(timeus_t) current time in microseconds
//-----------------------------------------------------------------------------
#define current_timeus() ({							\
	struct timeval libh__timeval;						\
	gettimeofday( & libh__timeval, NULL ) < 0				\
		? -1LL								\
		: ({								\
			long long libh__time;					\
			libh__time = libh__timeval.tv_sec;			\
			libh__time *= 1000000LL;				\
			libh__time += libh__timeval.tv_usec;			\
			libh__time;						\
		});								\
	})

__FMACRO_END__
