//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/time
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------
// reference	Explanatory Supplement to the Astronomical Almanac,
//		P. Kenneth Seidelmann, editor  [ISBN 0-935702-68-7]
//		http://shop.bn.com/bookSearch/isbnInquiry.asp?isbn=0935702687
//-----------------------------------------------------------------------------

#include <ctype.h>

#include "time_lib.h"

__PROTO_BEGIN__
//-----------------------------------------------------------------------------
// function	eday_get_ymd_julian
//
// purpose	Extract calendar elements in the Julian calendar from eday_t.
//
// arguments	1 (eday_t) Earth Day value
//		2 (long *) where to store year
//		3 (int *) where to store month
//		4 (int *) where to store day of month
//
// returns	(void)
//-----------------------------------------------------------------------------
void
eday_get_ymd_julian (
    eday_t	arg_eday
    ,
    long *	arg_year_p
    ,
    int *	arg_month_p
    ,
    int *	arg_mday_p
    )
__PROTO_END__
{
    ecal_t	ecal	;

    eday_to_ecal_julian( arg_eday, & ecal );
    if ( arg_year_p ) * arg_year_p = ecal.year;
    if ( arg_month_p ) * arg_month_p = ecal.month;
    if ( arg_mday_p ) * arg_mday_p = ecal.mday;
    return;
}
