//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/time
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "time_lib.h"

#include <langinfo.h>

__PROTO_BEGIN__
//-----------------------------------------------------------------------------
// function	month_name
//
// purpose	Given a month of year number in the range 0 to 11, return the
//		name of the month obtained from nl_langinfo() which will be
//		based on the current locale setting.
//
// arguments	1 (int) month of year number in the range 0 to 11
//
// returns	(const char *) pointer to string with month name.
//-----------------------------------------------------------------------------
const char *
month_name (
    int		arg_month_num
    )
__PROTO_END__
{
    static const nl_item	month_list	[12] = {
	MON_1, MON_2, MON_3, MON_4, MON_5, MON_6, MON_7, MON_8, MON_9, MON_10, MON_11, MON_12
    };
    return nl_langinfo( month_list[ mod_ni( arg_month_num, 12 ) ] );
}
