//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/time
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	str_julian_to_eday
//
// purpose	Convert date in a string to type eday for Julian calendar.
//
// arguments	1 (const char *) date and time string
//
// returns	(eday_t) == EDAY_ERROR: error
//		(eday_t) != EDAY_ERROR: date converted
//
// format	yyyy/mm/dd[_hh:mm:ss.nnnnnnnnnnnnnnnnnn]
//
// note		Any non-numeric character may be used as separators, but
//		such use should be limited to reasonable punctuation only
//		for future compatibility.
//
// note		Time parts may be specified but will be ignored.
//-----------------------------------------------------------------------------
#define str_julian_to_eday(s) ({						\
	long int	libh__year	;					\
	int		libh__month	;					\
	int		libh__mday	;					\
	const char *	libh__str	;					\
	libh__str = (s);							\
	( libh__str )								\
	? ({									\
		str_cal_to_ymd( libh__str, & libh__year, & libh__month, & libh__mday );	\
		ymd_julian_to_eday( libh__year, libh__month, libh__mday );		\
	})									\
	: EDAY_ERROR;								\
})

__FMACRO_END__
