//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/time
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------
// reference	Explanatory Supplement to the Astronomical Almanac,
//		P. Kenneth Seidelmann, editor  [ISBN 0-935702-68-7]
//		http://amazon.com/exec/obidos/ASIN/0935702687
//		http://shop.bn.com/bookSearch/isbnInquiry.asp?isbn=0935702687
//-----------------------------------------------------------------------------

#include "time_lib.h"

__PROTO_BEGIN__
//-----------------------------------------------------------------------------
// function	timems_to_timespec
//
// purpose	Convert system time in milliseconds to struct timespec.
//
// arguments	1 (struct timespec *) pointer to destination struct timespec
//		2 (timems_t) system time in milliseconds
//
// returns	(void)
//-----------------------------------------------------------------------------
void
timems_to_timespec (
    struct timespec *	arg_timets_p
    ,
    timens_t		arg_time_msec
    )
__PROTO_END__
{
    arg_timets_p->tv_sec = quo_ni( arg_time_msec, 1000UL );
    arg_timets_p->tv_nsec = mod_ni( arg_time_msec, 1000UL ) * 1000000UL;
    return;
}
