//-----------------------------------------------------------------------------
// Copyright  2004 - Philip Howard - All rights reserved
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//-----------------------------------------------------------------------------
// package	libh/time
// purpose	Support daemon startup
// homepage	http://libh.slashusr.org/
//-----------------------------------------------------------------------------
// author	Philip Howard
// email	libh at ipal dot org
// homepage	http://phil.ipal.org/
//-----------------------------------------------------------------------------
// This file is best viewed using a fixed spaced font such as Courier
// and in a display at least 120 columns wide.
//-----------------------------------------------------------------------------

#include "time_lib.h"

__FMACRO_BEGIN__
//-----------------------------------------------------------------------------
// macro	timer_prof_set_nsec
//
// purpose	Set the profile interval timer to signal the alarm at
//		expiration based on a time interval specified with a 64 bit
//		integer value.
//
// arguments	1 (number) time until alarm in nanoseconds
//
// returns	(int) -1 : error
//		(int)  0 : OK
//-----------------------------------------------------------------------------
#define timer_prof_set_nsec(t) ({						\
	struct itimerval libh__itimerval;					\
	timens_t libh__timens;							\
	libh__timens = ( t );							\
	libh__itimerval.it_interval.tv_sec = 0;					\
	libh__itimerval.it_interval.tv_usec = 0;				\
	libh__itimerval.it_value.tv_sec = libh__timens / 1000000000L;		\
	libh__itimerval.it_value.tv_usec = libh__timens / 1000L % 1000000L;	\
	setitimer( ( ITIMER_PROF ), & libh__itimerval, ( NULL ) );		\
})

__FMACRO_END__
